﻿Type=Class
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Library Attributes
	#Event: Click
	#Event: LongClick
	#Event: Change
#End Region

'Class Name: PinchZoomAndMove
'Author: Dominex
'Version: 1.44
'B4A Version Used: 2.52
'Last Modified: 26/04/2013
'-------------------------
'Class module
Public Sub Class_Globals
	Public G As Gestures
	Public Parent As Panel
	Public Touch As List
	Public rot As Boolean
	Public rg As RotateBitmap
	Public X0,Y0,X1,Y1,OrigW,OrigH As Int
	Public vCanMove,SingleClick,vBringToFront,LimitBorder,LimitArea As Boolean
	Public MovingTouch As Int = 10dip
	Public vTag,vModule As Object
	Public TimerLC As Timer
	Dim obj As View
	Public vEventName As String
	Public TimePress As Long
	Type TouchData (X As Int,Y As Int,Tag As Object)
	Public vTouchData As TouchData
	Type LayoutData (Left As Int,Top As Int,Width As Int,Height As Int,Tag As Object)
End Sub
Public Sub Initialize (Target As View,NameEvent As String,Tag As Object,BringToFront As Boolean,Module As Object)
	Touch.Initialize
	obj = Target
	vModule = Module
	SetOriginalSize
	vCanMove = True
	vEventName = NameEvent
	vTag = Tag
	vTouchData.Initialize
	vBringToFront = BringToFront
	G.SetOnTouchListener(obj,"Touch_Gestures")
End Sub

Private Sub SetOriginalSize
	OrigH = obj.Height
	OrigW = obj.Width
End Sub

'If True, the edges of the View will remain within its parent.
'If the View has dimensions infferiori the Parent, will be automatically increased.
'The zoom 100% Is equal To the new size of the View.
Public Sub SetLimitArea (Option As Boolean)
	LimitArea = Option
	LimitBorder = False
	Parent = GetParent(obj)
	If LimitAreaSize Then
		SetOriginalSize
		obj.Left = Parent.Width/2-obj.Width/2
		obj.top = Parent.Height/2-obj.Height/2
	Else
		obj.Left = Max(Min(obj.Left,0),Parent.Width-obj.Width)
		obj.Top = Max(Min(obj.Top,0),Parent.Height-obj.Height)
	End If
End Sub

'If it is true, the View will not come out from the edges of its parent.
'If the View Is larger than the Parent, will be automatically reduced.
'The 100% zoom Is equal To the new size of the View.
Public Sub SetLimitBorder (Option As Boolean)
	LimitBorder = Option
	LimitArea = False
	Parent = GetParent(obj)
	If LimitBorderSize Then
		SetOriginalSize
		obj.Left = Parent.Width/2-obj.Width/2
		obj.top = Parent.Height/2-obj.Height/2
	Else
		obj.Left = Min(Max(obj.Left,0),Parent.Width-obj.Width)
		obj.Top = Min(Max(obj.Top,0),Parent.Height-obj.Height)
	End If
End Sub

Private Sub LimitAreaSize As Boolean
	Dim Resize As Boolean
	Do While obj.Width<Parent.Width OR obj.Height<Parent.Height
		Resize = True
		If obj.Width < Parent.Width Then
			obj.Width = Parent.Width
			obj.Height = OrigH/OrigW*obj.Width
		Else If obj.Height < Parent.Height Then
			obj.Height = Parent.Height
			obj.Width = OrigW/OrigH*obj.Height
		End If
	Loop
	Return Resize
End Sub

Private Sub LimitBorderSize As Boolean
	Dim Resize As Boolean
	Do While obj.Width>Parent.Width OR obj.Height>Parent.Height
		Resize = True
		If obj.Width > Parent.Width Then
			obj.Width = Parent.Width
			obj.Height = OrigH/OrigW*obj.Width
		Else If obj.Height > Parent.Height Then
			obj.Height = Parent.Height
			obj.Width = OrigW/OrigH*obj.Height
		End If
	Loop
	Return Resize
End Sub
Public Sub SetIfCanMove (Option As Boolean)
	vCanMove = Option
End Sub

'Returns if the View can translate.
Public Sub GetIfCanMove As Boolean
	Return vCanMove
End Sub

Private Sub GetParent(v As View) As View
    Dim r As Reflector
    r.Target = v
    Return r.RunMethod("getParent")
End Sub

Private Sub Touch_Gestures(View As Object, PointerID As Int, Action As Int, X As Float, Y As Float) As Boolean
	Dim conta,xTemp,yTemp As Int
	rot=True
	rg.Initialize(rot,PointerID)
	Select Action
		Case G.ACTION_DOWN
		'CallSubDelayed(Main,"aas_Click")
		'rot.Initialize(obj,"PZ",Main)
			Touch.Add(PointerID)
			SingleClick = True
			If vBringToFront Then obj.BringToFront
			'TimePress = DateTime.Now
			'---Stores the position of View---
			X0 = X+obj.Left
			Y0 = Y+obj.Top
			X1 = obj.Left
			Y1 = obj.Top
		Case G.ACTION_POINTER_DOWN
			Touch.Add(PointerID)
			If Touch.Size = 2 Then 
				xTemp = G.GetX(Touch.Get(0))-G.GetX(Touch.Get(1))
				yTemp = G.GetY(Touch.Get(0))-G.GetY(Touch.Get(1))
			End If
			SingleClick = False
			
		Case G.ACTION_MOVE
			'---clears the first slight movement to the first pressure---
			
			If DateTime.Now-TimePress < 100 Then
				X0 = X+obj.Left
				Y0 = Y+obj.Top
				X1 = obj.Left
				Y1 = obj.Top
			End If
			If Touch.Size = 1 Then
				'---Move View---
				If vCanMove Then
					xTemp = X1+G.GetX(Touch.Get(0))+obj.Left-X0
					yTemp = Y1+G.GetY(Touch.Get(0))+obj.Top-Y0
					If LimitBorder Then
						xTemp = Min(Max(xTemp,0),Parent.Width-obj.Width)
						yTemp = Min(Max(yTemp,0),Parent.Height-obj.Height)
					Else If LimitArea Then
						xTemp = Max(Min(xTemp,0),Parent.Width-obj.Width)
						yTemp = Max(Min(yTemp,0),Parent.Height-obj.Height)
					End If
					obj.Left = xTemp
					obj.Top = yTemp
				End If
				If Abs(vTouchData.X-X) > MovingTouch OR Abs(vTouchData.Y-Y) > MovingTouch Then TimerLC.Enabled = False
			End If
		Case G.ACTION_POINTER_UP
			'---Removes touches are no longer present on the screen---
			For conta = 0 To Touch.Size-1
				If Touch.Get(conta) = PointerID Then
					Touch.RemoveAt(conta)
					Exit
				End If
			Next
		Case G.ACTION_UP
			Touch.Clear
			TimerLC.Enabled = False
			If Abs(X+obj.Left-X0) < MovingTouch AND Abs(Y+obj.Top-Y0) < MovingTouch AND SingleClick Then
				If SubExists(vModule,vEventName&"_Click") Then
					vTouchData.Tag = vTag
					CallSub2(vModule,vEventName&"_Click",vTouchData)
				End If
			End If
	End Select
	Log(Action)
	
	Return True
End Sub